Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 512)
@@ -25,10 +25,11 @@
 #define length(x) (sizeof(x) / sizeof(x[0]))
 
-extern "C" int yylex();
-extern "C" int crlex();
+extern "C" int yylex ();
+extern "C" int crlex ();
 
 #include "cgic.h"
 
-extern "C" {
+extern "C"
+{
 #include <libxml/tree.h>
 #include <libxml/xmlmemory.h>
@@ -36,4 +37,5 @@
 #include <libxml/xpath.h>
 #include <libxml/xpathInternals.h>
+#include "service_zcfg.h"
 }
 
@@ -45,4 +47,5 @@
 
 #include "service.h"
+
 
 #include "service_internal.h"
@@ -91,21 +94,22 @@
 
 #ifdef WIN32
-extern "C" {
-  __declspec(dllexport) char *strcasestr(char const *a, char const *b)
+extern "C"
+{
+  __declspec (dllexport) char *strcasestr (char const *a, char const *b)
 #ifndef USE_MS
- { 
-  char *x=zStrdup(a); 
-  char *y=zStrdup(b); 
-  
-  x=_strlwr(x); 
-  y=_strlwr(y); 
-  char *pos = strstr(x, y); 
-  char *ret = pos == NULL ? NULL : (char *)(a + (pos-x)); 
-  free(x); 
-  free(y); 
-  return ret; 
- };
+  {
+    char *x = zStrdup (a);
+    char *y = zStrdup (b);
+
+      x = _strlwr (x);
+      y = _strlwr (y);
+    char *pos = strstr (x, y);
+    char *ret = pos == NULL ? NULL : (char *) (a + (pos - x));
+      free (x);
+      free (y);
+      return ret;
+  };
 #else
-  ;
+   ;
 #endif
 }
@@ -115,22 +119,28 @@
 #define __(String) dgettext ("zoo-service",String)
 
-extern   int getServiceFromFile(maps*,const char*,service**);
-
-int readServiceFile(maps* conf, char* file,service** service,char *name){
-  int t=getServiceFromFile(conf,file,service);
+extern int getServiceFromFile (maps *, const char *, service **);
+
+int
+readServiceFile (maps * conf, char *file, service ** service, char *name)
+{
+  int t = getServiceFromFile (conf, file, service);
 #ifdef YAML
-  if(t<0){
-    t=getServiceFromYAML(conf,file,service,name);
-  }
+  if (t < 0)
+    {
+      t = getServiceFromYAML (conf, file, service, name);
+    }
 #endif
   return t;
 }
 
-void translateChar(char* str,char toReplace,char toReplaceBy){
-  int i=0,len=strlen(str);
-  for(i=0;i<len;i++){
-    if(str[i]==toReplace)
-      str[i]=toReplaceBy;
-  }
+void
+translateChar (char *str, char toReplace, char toReplaceBy)
+{
+  int i = 0, len = strlen (str);
+  for (i = 0; i < len; i++)
+    {
+      if (str[i] == toReplace)
+        str[i] = toReplaceBy;
+    }
 }
 
@@ -139,432 +149,540 @@
  * value = "["",""]"
  */
-int appendMapsToMaps(maps* m,maps* mo,maps* mi,elements* elem){
-  maps* tmpMaps=getMaps(mo,mi->name);
-  map* tmap=getMapType(tmpMaps->content);
-  elements* el=getElements(elem,mi->name);
-  int hasEl=1;
-  if(el==NULL)
-    hasEl=-1;
-  if(tmap==NULL){
-    if(hasEl>0)
-      tmap=getMapType(el->defaults->content);      
-  }
-
-  map* testMap=NULL;
-  if(hasEl>0){
-    testMap=getMap(el->content,"maxOccurs");
-  }else{
-    testMap=createMap("maxOccurs","unbounded");
-  }
-
-  if(testMap!=NULL){
-    if(strncasecmp(testMap->value,"unbounded",9)!=0 && atoi(testMap->value)>1){
-      if(addMapsArrayToMaps(&mo,mi,tmap->name)<0){
-	char emsg[1024];
-	sprintf(emsg,_("You set maximum occurences for <%s> as %i but you tried to use it more than the limit you set. Please correct your ZCFG file or your request."),mi->name,atoi(testMap->value));
-	errorException(m,emsg,"InternalError",NULL);
-	return -1;
-      }
-    }else{
-      if(strncasecmp(testMap->value,"unbounded",9)==0){
-	if(hasEl<0){
-	  freeMap(&testMap);
-	  free(testMap);
-	}
-	if(addMapsArrayToMaps(&mo,mi,tmap->name)<0){
-	  char emsg[1024];
-	  map* tmpMap=getMap(mi->content,"length");
-	  sprintf(emsg,_("ZOO-Kernel was unable to load your data for %s position %s."),mi->name,tmpMap->value);
-	  errorException(m,emsg,"InternalError",NULL);
-	  return -1;
-	}
-      }
-      else{
-	char emsg[1024];
-	sprintf(emsg,_("You set maximum occurences for <%s> to one but you tried to use it more than once. Please correct your ZCFG file or your request."),mi->name);
-	errorException(m,emsg,"InternalError",NULL);
-	return -1;
-      }
-    }
-  }
+int
+appendMapsToMaps (maps * m, maps * mo, maps * mi, elements * elem)
+{
+  maps *tmpMaps = getMaps (mo, mi->name);
+  map *tmap = getMapType (tmpMaps->content);
+  elements *el = getElements (elem, mi->name);
+  int hasEl = 1;
+  if (el == NULL)
+    hasEl = -1;
+  if (tmap == NULL)
+    {
+      if (hasEl > 0)
+        tmap = getMapType (el->defaults->content);
+    }
+
+  map *testMap = NULL;
+  if (hasEl > 0)
+    {
+      testMap = getMap (el->content, "maxOccurs");
+    }
+  else
+    {
+      testMap = createMap ("maxOccurs", "unbounded");
+    }
+
+  if (testMap != NULL)
+    {
+      if (strncasecmp (testMap->value, "unbounded", 9) != 0
+          && atoi (testMap->value) > 1)
+        {
+          if (addMapsArrayToMaps (&mo, mi, tmap->name) < 0)
+            {
+              char emsg[1024];
+              sprintf (emsg,
+                       _
+                       ("You set maximum occurences for <%s> as %i but you tried to use it more than the limit you set. Please correct your ZCFG file or your request."),
+                       mi->name, atoi (testMap->value));
+              errorException (m, emsg, "InternalError", NULL);
+              return -1;
+            }
+        }
+      else
+        {
+          if (strncasecmp (testMap->value, "unbounded", 9) == 0)
+            {
+              if (hasEl < 0)
+                {
+                  freeMap (&testMap);
+                  free (testMap);
+                }
+              if (addMapsArrayToMaps (&mo, mi, tmap->name) < 0)
+                {
+                  char emsg[1024];
+                  map *tmpMap = getMap (mi->content, "length");
+                  sprintf (emsg,
+                           _
+                           ("ZOO-Kernel was unable to load your data for %s position %s."),
+                           mi->name, tmpMap->value);
+                  errorException (m, emsg, "InternalError", NULL);
+                  return -1;
+                }
+            }
+          else
+            {
+              char emsg[1024];
+              sprintf (emsg,
+                       _
+                       ("You set maximum occurences for <%s> to one but you tried to use it more than once. Please correct your ZCFG file or your request."),
+                       mi->name);
+              errorException (m, emsg, "InternalError", NULL);
+              return -1;
+            }
+        }
+    }
   return 0;
 }
 
-int recursReaddirF(maps* m,xmlNodePtr n,char *conf_dir,char *prefix,int saved_stdout,int level,void (func) (maps*,xmlNodePtr,service*)){
+int
+recursReaddirF (maps * m, xmlNodePtr n, char *conf_dir, char *prefix,
+                int saved_stdout, int level, void (func) (maps *, xmlNodePtr,
+                                                          service *))
+{
   struct dirent *dp;
-  int scount=0;
-
-  if(conf_dir==NULL)
+  int scount = 0;
+
+  if (conf_dir == NULL)
     return 1;
-  DIR *dirp = opendir(conf_dir);
-  if(dirp==NULL){
-    if(level>0)
-      return 1;
+  DIR *dirp = opendir (conf_dir);
+  if (dirp == NULL)
+    {
+      if (level > 0)
+        return 1;
+      else
+        return -1;
+    }
+  char tmp1[25];
+  sprintf (tmp1, "sprefix_%d", level);
+  char levels[17];
+  sprintf (levels, "%d", level);
+  setMapInMaps (m, "lenv", "level", levels);
+  while ((dp = readdir (dirp)) != NULL)
+    if ((dp->d_type == DT_DIR || dp->d_type == DT_LNK) && dp->d_name[0] != '.'
+        && strstr (dp->d_name, ".") == NULL)
+      {
+
+        char *tmp =
+          (char *) malloc ((strlen (conf_dir) + strlen (dp->d_name) + 2) *
+                           sizeof (char));
+        sprintf (tmp, "%s/%s", conf_dir, dp->d_name);
+
+        if (prefix != NULL)
+          {
+            prefix = NULL;
+          }
+        prefix = (char *) malloc ((strlen (dp->d_name) + 2) * sizeof (char));
+        sprintf (prefix, "%s.", dp->d_name);
+
+        //map* tmpMap=getMapFromMaps(m,"lenv",tmp1);
+
+        int res;
+        if (prefix != NULL)
+          {
+            setMapInMaps (m, "lenv", tmp1, prefix);
+            char levels1[17];
+            sprintf (levels1, "%d", level + 1);
+            setMapInMaps (m, "lenv", "level", levels1);
+            res =
+              recursReaddirF (m, n, tmp, prefix, saved_stdout, level + 1,
+                              func);
+            sprintf (levels1, "%d", level);
+            setMapInMaps (m, "lenv", "level", levels1);
+            free (prefix);
+            prefix = NULL;
+          }
+        else
+          res = -1;
+        free (tmp);
+        if (res < 0)
+          {
+            return res;
+          }
+      }
     else
-      return -1;
-  }
-  char tmp1[25];
-  sprintf(tmp1,"sprefix_%d",level);
-  char levels[17];
-  sprintf(levels,"%d",level);
-  setMapInMaps(m,"lenv","level",levels);
-  while ((dp = readdir(dirp)) != NULL)
-    if((dp->d_type==DT_DIR || dp->d_type==DT_LNK) && dp->d_name[0]!='.' && strstr(dp->d_name,".")==NULL){
-
-      char *tmp=(char*)malloc((strlen(conf_dir)+strlen(dp->d_name)+2)*sizeof(char));
-      sprintf(tmp,"%s/%s",conf_dir,dp->d_name);
-
-      if(prefix!=NULL){
-	prefix=NULL;
+      {
+        if (dp->d_name[0] != '.' && strstr (dp->d_name, ".zcfg") != 0)
+          {
+            int t;
+            char tmps1[1024];
+            memset (tmps1, 0, 1024);
+            snprintf (tmps1, 1024, "%s/%s", conf_dir, dp->d_name);
+            service *s1 = (service *) malloc (SERVICE_SIZE);
+            if (s1 == NULL)
+              {
+                dup2 (saved_stdout, fileno (stdout));
+                errorException (m, _("Unable to allocate memory."),
+                                "InternalError", NULL);
+                return -1;
+              }
+#ifdef DEBUG
+            fprintf (stderr, "#################\n%s\n#################\n",
+                     tmps1);
+#endif
+            t = readServiceFile (m, tmps1, &s1, dp->d_name);
+
+            if (t < 0)
+              {
+                map *tmp00 = getMapFromMaps (m, "lenv", "message");
+                char tmp01[1024];
+                if (tmp00 != NULL)
+                  sprintf (tmp01, _("Unable to parse the ZCFG file: %s (%s)"),
+                           dp->d_name, tmp00->value);
+                else
+                  sprintf (tmp01, _("Unable to parse the ZCFG file: %s."),
+                           dp->d_name);
+                dup2 (saved_stdout, fileno (stdout));
+                errorException (m, tmp01, "InternalError", NULL);
+                freeMaps (&m);
+                free (m);
+                return -1;
+              }
+#ifdef DEBUG
+            dumpService (s1);
+            fflush (stdout);
+            fflush (stderr);
+#endif
+            func (m, n, s1);
+            freeService (&s1);
+            free (s1);
+            scount++;
+          }
       }
-      prefix=(char*)malloc((strlen(dp->d_name)+2)*sizeof(char));
-      sprintf(prefix,"%s.",dp->d_name);
-      
-      //map* tmpMap=getMapFromMaps(m,"lenv",tmp1);
-      
-      int res;
-      if(prefix!=NULL){
-	setMapInMaps(m,"lenv",tmp1,prefix);
-	char levels1[17];
-	sprintf(levels1,"%d",level+1);
-	setMapInMaps(m,"lenv","level",levels1);
-	res=recursReaddirF(m,n,tmp,prefix,saved_stdout,level+1,func);
-	sprintf(levels1,"%d",level);
-	setMapInMaps(m,"lenv","level",levels1);
-	free(prefix);
-	prefix=NULL;
-      }else
-	res=-1;
-      free(tmp);
-      if(res<0){
-	return res;
-      }
-    }
-    else{
-      if(dp->d_name[0]!='.' && strstr(dp->d_name,".zcfg")!=0){
-	int t;
-	char tmps1[1024];
-	memset(tmps1,0,1024);
-	snprintf(tmps1,1024,"%s/%s",conf_dir,dp->d_name);
-	service* s1=(service*)malloc(SERVICE_SIZE);
-	if(s1 == NULL){ 
-	  dup2(saved_stdout,fileno(stdout));
-	  errorException(m, _("Unable to allocate memory."),"InternalError",NULL);
-	  return -1;
-	}
-#ifdef DEBUG
-	fprintf(stderr,"#################\n%s\n#################\n",tmps1);
-#endif
-	t=readServiceFile(m,tmps1,&s1,dp->d_name);
-
-	if(t<0){
-	  map* tmp00=getMapFromMaps(m,"lenv","message");
-	  char tmp01[1024];
-	  if(tmp00!=NULL)
-	    sprintf(tmp01,_("Unable to parse the ZCFG file: %s (%s)"),dp->d_name,tmp00->value);
-	  else
-	    sprintf(tmp01,_("Unable to parse the ZCFG file: %s."),dp->d_name);
-	  dup2(saved_stdout,fileno(stdout));
-	  errorException(m, tmp01,"InternalError",NULL);
-	  freeMaps(&m);
-	  free(m);
-	  return -1;
-	}
-#ifdef DEBUG
-	dumpService(s1);
-	fflush(stdout);
-	fflush(stderr);
-#endif
-	func(m,n,s1);
-	freeService(&s1);
-	free(s1);
-	scount++;
-      }
-    }
-  (void)closedir(dirp);
+  (void) closedir (dirp);
   return 1;
 }
 
-xmlXPathObjectPtr extractFromDoc(xmlDocPtr doc,const char* search){
+xmlXPathObjectPtr
+extractFromDoc (xmlDocPtr doc, const char *search)
+{
   xmlXPathContextPtr xpathCtx;
   xmlXPathObjectPtr xpathObj;
-  xpathCtx = xmlXPathNewContext(doc);
-  xpathObj = xmlXPathEvalExpression(BAD_CAST search,xpathCtx);
-  xmlXPathFreeContext(xpathCtx);
+  xpathCtx = xmlXPathNewContext (doc);
+  xpathObj = xmlXPathEvalExpression (BAD_CAST search, xpathCtx);
+  xmlXPathFreeContext (xpathCtx);
   return xpathObj;
 }
 
-void donothing(int sig){
-#ifdef DEBUG
-  fprintf(stderr,"Signal %d after the ZOO-Kernel returned result !\n",sig);
-#endif
-  exit(0);
+void
+donothing (int sig)
+{
+#ifdef DEBUG
+  fprintf (stderr, "Signal %d after the ZOO-Kernel returned result !\n", sig);
+#endif
+  exit (0);
 }
 
-void sig_handler(int sig){
+void
+sig_handler (int sig)
+{
   char tmp[100];
   const char *ssig;
-  switch(sig){
-  case SIGSEGV:
-    ssig="SIGSEGV";
-    break;
-  case SIGTERM:
-    ssig="SIGTERM";
-    break;
-  case SIGINT:
-    ssig="SIGINT";
-    break;
-  case SIGILL:
-    ssig="SIGILL";
-    break;
-  case SIGFPE:
-    ssig="SIGFPE";
-    break;
-  case SIGABRT:
-    ssig="SIGABRT";
-    break;
-  default:
-    ssig="UNKNOWN";
-    break;
-  }
-  sprintf(tmp,_("ZOO Kernel failed to process your request receiving signal %d = %s"),sig,ssig);
-  errorException(NULL, tmp, "InternalError",NULL);
-#ifdef DEBUG
-  fprintf(stderr,"Not this time!\n");
-#endif
-  exit(0);
+  switch (sig)
+    {
+    case SIGSEGV:
+      ssig = "SIGSEGV";
+      break;
+    case SIGTERM:
+      ssig = "SIGTERM";
+      break;
+    case SIGINT:
+      ssig = "SIGINT";
+      break;
+    case SIGILL:
+      ssig = "SIGILL";
+      break;
+    case SIGFPE:
+      ssig = "SIGFPE";
+      break;
+    case SIGABRT:
+      ssig = "SIGABRT";
+      break;
+    default:
+      ssig = "UNKNOWN";
+      break;
+    }
+  sprintf (tmp,
+           _
+           ("ZOO Kernel failed to process your request receiving signal %d = %s"),
+           sig, ssig);
+  errorException (NULL, tmp, "InternalError", NULL);
+#ifdef DEBUG
+  fprintf (stderr, "Not this time!\n");
+#endif
+  exit (0);
 }
 
-void loadServiceAndRun(maps **myMap,service* s1,map* request_inputs,maps **inputs,maps** ioutputs,int* eres){
+void
+loadServiceAndRun (maps ** myMap, service * s1, map * request_inputs,
+                   maps ** inputs, maps ** ioutputs, int *eres)
+{
   char tmps1[1024];
   char ntmp[1024];
-  maps *m=*myMap;
-  maps *request_output_real_format=*ioutputs;
-  maps *request_input_real_format=*inputs;
+  maps *m = *myMap;
+  maps *request_output_real_format = *ioutputs;
+  maps *request_input_real_format = *inputs;
   /**
    * Extract serviceType to know what kind of service should be loaded
    */
-  map* r_inputs=NULL;
+  map *r_inputs = NULL;
 #ifndef WIN32
-  getcwd(ntmp,1024);
+  getcwd (ntmp, 1024);
 #else
-  _getcwd(ntmp,1024);
-#endif
-  r_inputs=getMap(s1->content,"serviceType");
-#ifdef DEBUG
-  fprintf(stderr,"LOAD A %s SERVICE PROVIDER \n",r_inputs->value);
-  fflush(stderr);
-#endif
-  if(strlen(r_inputs->value)==1 && strncasecmp(r_inputs->value,"C",1)==0){
-    r_inputs=getMap(request_inputs,"metapath");
-    if(r_inputs!=NULL)
-      sprintf(tmps1,"%s/%s",ntmp,r_inputs->value);
-    else
-      sprintf(tmps1,"%s/",ntmp);
-    char *altPath=zStrdup(tmps1);
-    r_inputs=getMap(s1->content,"ServiceProvider");
-    sprintf(tmps1,"%s/%s",altPath,r_inputs->value);
-    free(altPath);
-#ifdef DEBUG
-    fprintf(stderr,"Trying to load %s\n",tmps1);
+  _getcwd (ntmp, 1024);
+#endif
+  r_inputs = getMap (s1->content, "serviceType");
+#ifdef DEBUG
+  fprintf (stderr, "LOAD A %s SERVICE PROVIDER \n", r_inputs->value);
+  fflush (stderr);
+#endif
+  if (strlen (r_inputs->value) == 1
+      && strncasecmp (r_inputs->value, "C", 1) == 0)
+    {
+      r_inputs = getMap (request_inputs, "metapath");
+      if (r_inputs != NULL)
+        sprintf (tmps1, "%s/%s", ntmp, r_inputs->value);
+      else
+        sprintf (tmps1, "%s/", ntmp);
+      char *altPath = zStrdup (tmps1);
+      r_inputs = getMap (s1->content, "ServiceProvider");
+      sprintf (tmps1, "%s/%s", altPath, r_inputs->value);
+      free (altPath);
+#ifdef DEBUG
+      fprintf (stderr, "Trying to load %s\n", tmps1);
 #endif
 #ifdef WIN32
-    HINSTANCE so = LoadLibraryEx(tmps1,NULL,LOAD_WITH_ALTERED_SEARCH_PATH);
+      HINSTANCE so =
+        LoadLibraryEx (tmps1, NULL, LOAD_WITH_ALTERED_SEARCH_PATH);
 #else
-    void* so = dlopen(tmps1, RTLD_LAZY);
+      void *so = dlopen (tmps1, RTLD_LAZY);
 #endif
 #ifdef WIN32
-    DWORD errstr;
-    errstr = GetLastError();
+      DWORD errstr;
+      errstr = GetLastError ();
 #else
-    char *errstr;
-    errstr = dlerror();
-#endif
-#ifdef DEBUG
-    fprintf(stderr,"%s loaded (%d) \n",tmps1,errstr);
-#endif
-    if( so != NULL ) {
-#ifdef DEBUG
-      fprintf(stderr,"Library loaded %s \n",errstr);
-      fprintf(stderr,"Service Shared Object = %s\n",r_inputs->value);
-#endif
-      r_inputs=getMap(s1->content,"serviceType");
-#ifdef DEBUG
-      dumpMap(r_inputs);
-      fprintf(stderr,"%s\n",r_inputs->value);
-      fflush(stderr);
-#endif
-      if(strncasecmp(r_inputs->value,"C-FORTRAN",9)==0){
-	r_inputs=getMap(request_inputs,"Identifier");
-	char fname[1024];
-	sprintf(fname,"%s_",r_inputs->value);
-#ifdef DEBUG
-	fprintf(stderr,"Try to load function %s\n",fname);
+      char *errstr;
+      errstr = dlerror ();
+#endif
+#ifdef DEBUG
+      fprintf (stderr, "%s loaded (%d) \n", tmps1, errstr);
+#endif
+      if (so != NULL)
+        {
+#ifdef DEBUG
+          fprintf (stderr, "Library loaded %s \n", errstr);
+          fprintf (stderr, "Service Shared Object = %s\n", r_inputs->value);
+#endif
+          r_inputs = getMap (s1->content, "serviceType");
+#ifdef DEBUG
+          dumpMap (r_inputs);
+          fprintf (stderr, "%s\n", r_inputs->value);
+          fflush (stderr);
+#endif
+          if (strncasecmp (r_inputs->value, "C-FORTRAN", 9) == 0)
+            {
+              r_inputs = getMap (request_inputs, "Identifier");
+              char fname[1024];
+              sprintf (fname, "%s_", r_inputs->value);
+#ifdef DEBUG
+              fprintf (stderr, "Try to load function %s\n", fname);
 #endif
 #ifdef WIN32
-	typedef int (CALLBACK* execute_t)(char***,char***,char***);
-	execute_t execute=(execute_t)GetProcAddress(so,fname);
+              typedef int (CALLBACK * execute_t) (char ***, char ***,
+                                                  char ***);
+              execute_t execute = (execute_t) GetProcAddress (so, fname);
 #else
-	typedef int (*execute_t)(char***,char***,char***);
-	execute_t execute=(execute_t)dlsym(so,fname);
+              typedef int (*execute_t) (char ***, char ***, char ***);
+              execute_t execute = (execute_t) dlsym (so, fname);
 #endif
 #ifdef DEBUG
 #ifdef WIN32
-	errstr = GetLastError();
+              errstr = GetLastError ();
 #else
-	errstr = dlerror();
-#endif
-	fprintf(stderr,"Function loaded %s\n",errstr);
-#endif	
-
-	char main_conf[10][30][1024];
-	char inputs[10][30][1024];
-	char outputs[10][30][1024];
-	for(int i=0;i<10;i++){
-	  for(int j=0;j<30;j++){
-	    memset(main_conf[i][j],0,1024);
-	    memset(inputs[i][j],0,1024);
-	    memset(outputs[i][j],0,1024);
-	  }
-	}
-	mapsToCharXXX(m,(char***)main_conf);
-	mapsToCharXXX(request_input_real_format,(char***)inputs);
-	mapsToCharXXX(request_output_real_format,(char***)outputs);
-	*eres=execute((char***)&main_conf[0],(char***)&inputs[0],(char***)&outputs[0]);
-#ifdef DEBUG
-	fprintf(stderr,"Function run successfully \n");
-#endif
-	charxxxToMaps((char***)&outputs[0],&request_output_real_format);
-      }else{
+              errstr = dlerror ();
+#endif
+              fprintf (stderr, "Function loaded %s\n", errstr);
+#endif
+
+              char main_conf[10][30][1024];
+              char inputs[10][30][1024];
+              char outputs[10][30][1024];
+              for (int i = 0; i < 10; i++)
+                {
+                  for (int j = 0; j < 30; j++)
+                    {
+                      memset (main_conf[i][j], 0, 1024);
+                      memset (inputs[i][j], 0, 1024);
+                      memset (outputs[i][j], 0, 1024);
+                    }
+                }
+              mapsToCharXXX (m, (char ***) main_conf);
+              mapsToCharXXX (request_input_real_format, (char ***) inputs);
+              mapsToCharXXX (request_output_real_format, (char ***) outputs);
+              *eres =
+                execute ((char ***) &main_conf[0], (char ***) &inputs[0],
+                         (char ***) &outputs[0]);
+#ifdef DEBUG
+              fprintf (stderr, "Function run successfully \n");
+#endif
+              charxxxToMaps ((char ***) &outputs[0],
+                             &request_output_real_format);
+            }
+          else
+            {
 #ifdef DEBUG
 #ifdef WIN32
-	errstr = GetLastError();
-	fprintf(stderr,"Function %s failed to load because of %d\n",r_inputs->value,errstr);
-#endif
-#endif
-	r_inputs=getMapFromMaps(m,"lenv","Identifier");
-#ifdef DEBUG
-	fprintf(stderr,"Try to load function %s\n",r_inputs->value);
-#endif
-	typedef int (*execute_t)(maps**,maps**,maps**);
+              errstr = GetLastError ();
+              fprintf (stderr, "Function %s failed to load because of %d\n",
+                       r_inputs->value, errstr);
+#endif
+#endif
+              r_inputs = getMapFromMaps (m, "lenv", "Identifier");
+#ifdef DEBUG
+              fprintf (stderr, "Try to load function %s\n", r_inputs->value);
+#endif
+              typedef int (*execute_t) (maps **, maps **, maps **);
 #ifdef WIN32
-	execute_t execute=(execute_t)GetProcAddress(so,r_inputs->value); 
+              execute_t execute =
+                (execute_t) GetProcAddress (so, r_inputs->value);
 #else
-	execute_t execute=(execute_t)dlsym(so,r_inputs->value);
-#endif
-
-	if(execute==NULL){
+              execute_t execute = (execute_t) dlsym (so, r_inputs->value);
+#endif
+
+              if (execute == NULL)
+                {
 #ifdef WIN32
-	  errstr = GetLastError();
+                  errstr = GetLastError ();
 #else
-	  errstr = dlerror();
-#endif
-	  char *tmpMsg=(char*)malloc(2048+strlen(r_inputs->value));
-	  sprintf(tmpMsg,_("Error occured while running the %s function: %s"),r_inputs->value,errstr);
-	  errorException(m, tmpMsg, "InternalError",NULL);
-	  free(tmpMsg);
-#ifdef DEBUG
-	  fprintf(stderr,"Function %s error %s\n",r_inputs->value,errstr);
-#endif
-	  *eres=-1;
-	  return;
-	}
+                  errstr = dlerror ();
+#endif
+                  char *tmpMsg =
+                    (char *) malloc (2048 + strlen (r_inputs->value));
+                  sprintf (tmpMsg,
+                           _
+                           ("Error occured while running the %s function: %s"),
+                           r_inputs->value, errstr);
+                  errorException (m, tmpMsg, "InternalError", NULL);
+                  free (tmpMsg);
+#ifdef DEBUG
+                  fprintf (stderr, "Function %s error %s\n", r_inputs->value,
+                           errstr);
+#endif
+                  *eres = -1;
+                  return;
+                }
 
 #ifdef DEBUG
 #ifdef WIN32
-	errstr = GetLastError();
+              errstr = GetLastError ();
 #else
-	errstr = dlerror();
-#endif
-	fprintf(stderr,"Function loaded %s\n",errstr);
-#endif	
-
-#ifdef DEBUG
-	fprintf(stderr,"Now run the function \n");
-	fflush(stderr);
-#endif
-	*eres=execute(&m,&request_input_real_format,&request_output_real_format);
-#ifdef DEBUG
-	fprintf(stderr,"Function loaded and returned %d\n",eres);
-	fflush(stderr);
-#endif
-      }
+              errstr = dlerror ();
+#endif
+              fprintf (stderr, "Function loaded %s\n", errstr);
+#endif
+
+#ifdef DEBUG
+              fprintf (stderr, "Now run the function \n");
+              fflush (stderr);
+#endif
+              *eres =
+                execute (&m, &request_input_real_format,
+                         &request_output_real_format);
+#ifdef DEBUG
+              fprintf (stderr, "Function loaded and returned %d\n", eres);
+              fflush (stderr);
+#endif
+            }
 #ifdef WIN32
-      *ioutputs=dupMaps(&request_output_real_format);
-      FreeLibrary(so);
+          *ioutputs = dupMaps (&request_output_real_format);
+          FreeLibrary (so);
 #else
-      dlclose(so);
-#endif
-    } else {
+          dlclose (so);
+#endif
+        }
+      else
+        {
       /**
        * Unable to load the specified shared library
        */
-      char tmps[1024];
+          char tmps[1024];
 #ifdef WIN32
-      DWORD errstr = GetLastError();
+          DWORD errstr = GetLastError ();
 #else
-      char* errstr = dlerror();
-#endif
-      sprintf(tmps,_("C Library can't be loaded %s"),errstr);
-      map* tmps1=createMap("text",tmps);
-      printExceptionReportResponse(m,tmps1);
-      *eres=-1;
-      freeMap(&tmps1);
-      free(tmps1);
-    }
-  }
+          char *errstr = dlerror ();
+#endif
+          sprintf (tmps, _("C Library can't be loaded %s"), errstr);
+          map *tmps1 = createMap ("text", tmps);
+          printExceptionReportResponse (m, tmps1);
+          *eres = -1;
+          freeMap (&tmps1);
+          free (tmps1);
+        }
+    }
   else
 #ifdef USE_PYTHON
-    if(strncasecmp(r_inputs->value,"PYTHON",6)==0){
-      *eres=zoo_python_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
-    }
-    else
-#endif
-	
+  if (strncasecmp (r_inputs->value, "PYTHON", 6) == 0)
+    {
+      *eres =
+        zoo_python_support (&m, request_inputs, s1,
+                            &request_input_real_format,
+                            &request_output_real_format);
+    }
+  else
+#endif
+
 #ifdef USE_JAVA
-      if(strncasecmp(r_inputs->value,"JAVA",4)==0){
-	*eres=zoo_java_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
-      }
-      else
+  if (strncasecmp (r_inputs->value, "JAVA", 4) == 0)
+    {
+      *eres =
+        zoo_java_support (&m, request_inputs, s1, &request_input_real_format,
+                          &request_output_real_format);
+    }
+  else
 #endif
 
 #ifdef USE_PHP
-	if(strncasecmp(r_inputs->value,"PHP",3)==0){
-	  *eres=zoo_php_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
-	}
-	else
-#endif
-	    
-	    
+  if (strncasecmp (r_inputs->value, "PHP", 3) == 0)
+    {
+      *eres =
+        zoo_php_support (&m, request_inputs, s1, &request_input_real_format,
+                         &request_output_real_format);
+    }
+  else
+#endif
+
+
 #ifdef USE_PERL
-          if(strncasecmp(r_inputs->value,"PERL",4)==0){
-            *eres=zoo_perl_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
-          }
-          else
+  if (strncasecmp (r_inputs->value, "PERL", 4) == 0)
+    {
+      *eres =
+        zoo_perl_support (&m, request_inputs, s1, &request_input_real_format,
+                          &request_output_real_format);
+    }
+  else
 #endif
 
 #ifdef USE_JS
-	    if(strncasecmp(r_inputs->value,"JS",2)==0){
-	      *eres=zoo_js_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
-	    }
-	    else
+  if (strncasecmp (r_inputs->value, "JS", 2) == 0)
+    {
+      *eres =
+        zoo_js_support (&m, request_inputs, s1, &request_input_real_format,
+                        &request_output_real_format);
+    }
+  else
 #endif
 
 #ifdef USE_RUBY
-          if(strncasecmp(r_inputs->value,"Ruby",4)==0){
-            *eres=zoo_ruby_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
-          }
-          else
-#endif
-
-	      {
-		char tmpv[1024];
-		sprintf(tmpv,_("Programming Language (%s) set in ZCFG file is not currently supported by ZOO Kernel.\n"),r_inputs->value);
-		map* tmps=createMap("text",tmpv);
-		printExceptionReportResponse(m,tmps);
-		*eres=-1;
-	      }
-  *myMap=m;
-  *ioutputs=request_output_real_format;
+  if (strncasecmp (r_inputs->value, "Ruby", 4) == 0)
+    {
+      *eres =
+        zoo_ruby_support (&m, request_inputs, s1, &request_input_real_format,
+                          &request_output_real_format);
+    }
+  else
+#endif
+
+    {
+      char tmpv[1024];
+      sprintf (tmpv,
+               _
+               ("Programming Language (%s) set in ZCFG file is not currently supported by ZOO Kernel.\n"),
+               r_inputs->value);
+      map *tmps = createMap ("text", tmpv);
+      printExceptionReportResponse (m, tmps);
+      *eres = -1;
+    }
+  *myMap = m;
+  *ioutputs = request_output_real_format;
 }
 
